from typing import Tuple

import pygame as pg

vec = pg.math.Vector2

CAPTION: str = 'Tetris Pygame Demo'
FPS: float = 60
FIELD_COLOR: Tuple[int, int, int] = (48, 39, 32)

TILE_SIZE = 20
FIELD_SIZE = FIELD_W, FIELD_H = 20, 30
FIELD_RES = FIELD_W * TILE_SIZE, FIELD_H * TILE_SIZE
INITIAL_FALL_TIMEOUT = 500  # millseconds, tetromino fall countdown

MOVE_DIRECTIONS = {
    'l': vec(-1, 0),
    'r': vec(1, 0),
    'd': vec(0, 1)
}

TETROMINO_COLORS = [  # https://www.pygame.org/docs/ref/color_list.html
    'cyan2', 'aqua', 'firebrick', 'forestgreen', 'orange', 'antiquewhite'
]
TETROMINOES = {
    'T': ((0, 0), (-1, 0), (1, 0), (0, -1)),
    'O': ((0, 0), (0, -1), (-1, 0), (-1, -1)),
    'J': ((0, 0), (-1, 0), (0, -1), (0, -2)),
    'L': ((0, 0), (-1, 0), (-1, -1), (-1, -2)),
    'I': ((0, 0), (0, 1), (0, -1), (0, -2)),
    'S': ((0, 0), (-1, 0), (0, -1), (1, -1)),
    'Z': ((0, 0), (1, 0), (0, -1), (-1, -1))
}
